#!/usr/bin/env python

"A calendar application."

import WebStack.Generic

class DirectoryResource:

    """
    A resource which handles incoming calendars and viewing requests.
    An arbitrary set of rules can be applied to determine what is to be done
    with a request, and in this case, the application appears as a directory of
    calendars, yet also accepts incoming calendars.
    """

    def respond(self, trans):

        """
        Examine the incoming request, either saving a calendar or displaying
        one.
        """

        # Get the last path component as the name of the calendar.
        # NOTE: This could be improved to permit hierarchical naming.

        calendar_name = trans.get_path_without_query().split("/")[-1]

        # Determine the action to be taken.

        method = trans.get_request_method()
        print method

        # NOTE: Some frameworks do not pass in the content type.

        content_type = trans.get_content_type()

        if method == "PUT":
            input = trans.get_request_stream()
            print "Name:", calendar_name
            print "Content type:", content_type.content_type
            print "--------"
            print input.read()
            print "--------"
        else:

            # NOTE: Send the appropriate kind of response.

            trans.set_content_type(WebStack.Generic.ContentType("text/html"))
            out = trans.get_response_stream()
            out.write("<html><body><h1>Calendar %s</h1></body></html>" % calendar_name)

# vim: tabstop=4 expandtab shiftwidth=4
